package com.esignlive.guidance.forum;
import java.util.Arrays;
import java.util.List;

import com.silanis.esl.sdk.DocumentPackage;
import com.silanis.esl.sdk.EslClient;
import com.silanis.esl.sdk.PackageId;
import com.silanis.esl.sdk.TextAnchorPosition;
import com.silanis.esl.sdk.builder.DocumentBuilder;
import com.silanis.esl.sdk.builder.PackageBuilder;
import com.silanis.esl.sdk.builder.SignatureBuilder;
import com.silanis.esl.sdk.builder.SignerBuilder;
import com.silanis.esl.sdk.builder.TextAnchorBuilder;


public class _21_06_18_TextAnchor {
	public static final String API_KEY = "your_api_key";
	public static final String API_URL = "https://sandbox.esignlive.com/api";
	public static final String FILE_PATH = "path_to_file\\L2_Document with _EsignStrings (5).docx";

	public static void main(String[] args) {
		
		EslClient client = new EslClient(API_KEY, API_URL);
		
		List<String> signerEmail = Arrays.asList("esignguide1@mailinator.com","esignguide2@mailinator.com","esignguide3@mailinator.com");
		
		DocumentBuilder documentBuilder = DocumentBuilder.newDocumentWithName("Sample Contract")
	        .fromFile(FILE_PATH)
	        .enableExtraction();
		
		for (int i = 0; i < 3; i++) {
			for (int j = 0; j < 3; j++) {
				SignatureBuilder signatureBuilder = SignatureBuilder.signatureFor(signerEmail.get(i))
														.withPositionAnchor(TextAnchorBuilder.newTextAnchor("**Signer "+(i+1)+"**")
													        .atPosition(TextAnchorPosition.TOPLEFT)
													        .withSize(150, 40)
													        .withOffset(0, 0)
													        .withCharacter(0)
													        .withOccurence(j));
				documentBuilder.withSignature(signatureBuilder);
			}
		}
		
		DocumentPackage pkg = PackageBuilder.newPackageNamed("Text Anchor Extraction Example Java SDK")
		         .withSigner(SignerBuilder.newSignerWithEmail(signerEmail.get(0)) 
			              .withFirstName("John")
			              .withLastName("Smith")
			              .withCustomId("Signer1"))
		         .withSigner(SignerBuilder.newSignerWithEmail(signerEmail.get(1)) 
			              .withFirstName("John")
			              .withLastName("Mary")
			              .withCustomId("Signer2"))
		         .withSigner(SignerBuilder.newSignerWithEmail(signerEmail.get(2)) 
			              .withFirstName("Sam")
			              .withLastName("Russell")
			              .withCustomId("Signer3"))
		         .withDocument(documentBuilder)
		         .build();
	
		PackageId packageId = client.createPackageOneStep(pkg);
		
		System.out.println(packageId);
	}

}
